<template>
  <div class="messaging-message-list-compose">
    <h4>Send a message</h4>
    <VForm
      name="messaging-message-list-compose"
      :fields="fields"
      :modelState="modelState"
      buttonText="Send"
      buttonIconClass="bi bi-envelop-fill"
      :busy="sending"
      busyButtonText="Sending..."
      @submit="onSubmit"
    />
  </div>
</template>

<script>
import { ref } from 'vue'
import { useStore } from 'vuex'
import { VForm, useVForm, useApi, useNotification } from '../../core'
import { useAuth } from '../../identity'
import MessagesApi from '../api/messages-api.js'

export default {
  name: 'MessagingMessageListCompose',
  emits: ['messageSent'],
  components: {
    VForm,
  },
  props: {
    username: { type: String, required: true },
  },
  setup(_, context) {
    const store = useStore()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const vform = useVForm()
    const messagesApi = new MessagesApi(api, auth)

    const modelState = ref({})
    const sending = ref(false)
    const fields = ref([
      {
        type: 'markdown',
        name: 'body',
        validate: 'required',
        value: '',
      },
    ])

    const onSubmit = async (form) => {
      sending.value = true
      try {
        const response = await messagesApi.createAsync(store.state.identity.session.username, form)
        fields.value = vform.set(fields.value, { body: '' })
        context.emit('messageSent', response.data)
      } catch (ex) {
        if (ex?.response.data?.modelState) {
          modelState.value = ex.response.data.modelState
        } else {
          notify.error('There was a problem sending your message.', ex)
        }
      } finally {
        sending.value = false
      }
    }

    return {
      modelState,
      sending,
      fields,
      onSubmit,
    }
  },
}
</script>

<style lang="scss">
@use '../../core/sass/vars';

.messaging-message-list-compose {
  margin-top: vars.$spacing * 2;
}
</style>
